format MS COFF
public _start

Include '%fasminc%\win32a.inc'
Include '%fasminc%\macro\if.inc'
include '..\..\..\extrndef.inc'
include 'kernel32.inc'
include 'user32.inc'

section '.data' data readable writeable

rsrc		db 'MyDialog',0
caption		db "Listbox example",0
item1		db 'Item1',0
item2		db 'Item2',0
item3		db 'Item3',0

hCursor		dd ?
hInstance	dd ?
CommandLine	dd ?
hListBox	dd ?
IndexItem	dd ?
buffer		rb 10

section '.text' code readable executable

_start:
	invoke	GetModuleHandle, NULL
	mov	[hInstance],eax
	invoke	DialogBoxParam,[hInstance],rsrc,NULL,DlgProc,NULL
	invoke	ExitProcess,eax

proc DlgProc hWnd,uMsg,wParam,lParam
	
	.if [uMsg],e,WM_CLOSE
		invoke	EndDialog,[hWnd],NULL
	
	.elseif [uMsg],e,WM_INITDIALOG	
		invoke	LoadCursor,0,IDC_CROSS
		mov	[hCursor],eax
		invoke	GetDlgItem,[hWnd],1001
		mov	[hListBox],eax
		invoke	SendMessage,[hListBox],LB_ADDSTRING,0,item1
		invoke	SendMessage,[hListBox],LB_ADDSTRING,0,item2			
		invoke	SendMessage,[hListBox],LB_ADDSTRING,0,item3
	
	.elseif [uMsg],e,WM_SETCURSOR
		invoke	SetCursor,[hCursor]

	.elseif [uMsg],e,WM_COMMAND
		mov	edx,[wParam]
		shr	edx,16
		.if dx,e,LBN_DBLCLK 
			invoke	SendMessage,[hListBox],LB_GETCURSEL,0,0
          		mov	[IndexItem], eax
        		invoke	SendMessage,[hListBox],LB_GETTEXT,[IndexItem],buffer
			invoke	MessageBox,0,buffer,caption,MB_OK
		.endif
	.else
		mov	eax,FALSE
		ret
	.endif
	mov	eax,TRUE
	ret
endp